Matches URLs against patterns.

Matches URLs against patterns and extracts named parameters from the path or the search part of the URL.

A URL pattern consists of a path pattern, optionally followed by '?' and a list of search (query) parameters. Multiple search parameter names are separated by '&'. Search parameters do not influence whether or not a URL is matched, but their values are passed through into the matched parameters returned by UrlMatcher.exec.

- Path parameters are defined using curly brace placeholders (`/somepath/{param}`) or colon placeholders (`/somePath/:param`).

- A parameter RegExp may be defined for a param after a colon (`/somePath/{param:[a-zA-Z0-9]+}`) in a curly brace placeholder. The regexp must match for the url to be matched. Should the regexp itself contain curly braces, they must be in matched pairs or escaped with a backslash.

Note: a RegExp parameter will encode its value using either ParamTypes.path or ParamTypes.query.

- Custom parameter types may also be specified after a colon (`/somePath/{param:int}`) in curly brace parameters. See UrlMatcherFactory.type for more information.

- Catch-all parameters are defined using an asterisk placeholder (`/somepath/*catchallparam`). A catch-all * parameter value will contain the remainder of the URL.

Parameter names may contain only word characters (latin letters, digits, and underscore) and must be unique within the pattern (across both path and search parameters). A path parameter matches any number of characters other than '/'. For catch-all placeholders the path parameter matches any number of characters.

Examples:

- `'/hello/'` - Matches only if the path is exactly '/hello/'. There is no special treatment for trailing slashes, and patterns have to match the entire path, not just a prefix.
- `'/user/:id'` - Matches '/user/bob' or '/user/1234!!!' or even '/user/' but not '/user' or '/user/bob/details'. The second path segment will be captured as the parameter 'id'.
- `'/user/{id}'` - Same as the previous example, but using curly brace syntax.
- `'/user/{id:[^/]*}'` - Same as the previous example.
- `'/user/{id:[0-9a-fA-F]{1,8}}'` - Similar to the previous example, but only matches if the id parameter consists of 1 to 8 hex digits.
- `'/files/{path:.*}'` - Matches any URL starting with '/files/' and captures the rest of the path into the parameter 'path'.
- `'/files/*path'` - ditto.
- `'/calendar/{start:date}'` - Matches "/calendar/2014-11-12" (because the pattern defined in the built-in `date` ParamType matches `2014-11-12`) and provides a Date object in $stateParams.start

### Hierarchy

- UrlMatcher

## Index

### Constructors

- constructor

### Properties

- config
- pattern

### Methods

- append
- exec
- format
- toString
- validates
- compare

## Constructors

- new UrlMatcher(pattern: string, paramTypes: ParamTypes, paramFactory: ParamFactory, config?: any): UrlMatcher

- #### Parameters

  - ##### pattern string

    :

    The pattern to compile into a matcher.

  - ##### paramTypes ParamTypes

    :

    The ParamTypes registry

  - ##### paramFactory ParamFactory

  - ##### config: Optional any

    :

    A configuration object

    - `caseInsensitive` - `true` if URL matching should be case insensitive, otherwise `false`, the default value (for backward compatibility) is `false`.
    - `strict` - `false` if matching against a URL with a trailing slash should be treated as equivalent to a URL without a trailing slash, the default value is `true`.

  #### Returns UrlMatcher

  - Defined in url/urlMatcher.ts:202

## Properties

config: any

A configuration object

- `caseInsensitive` - `true` if URL matching should be case insensitive, otherwise `false`, the default value (for backward compatibility) is `false`.
- `strict` - `false` if matching against a URL with a trailing slash should be treated as equivalent to a URL without a trailing slash, the default value is `true`.

A configuration object

- `caseInsensitive` - `true` if URL matching should be case insensitive, otherwise `false`, the default value (for backward compatibility) is `false`.
- `strict` - `false` if matching against a URL with a trailing slash should be treated as equivalent to a URL without a trailing slash, the default value is `true`.

- Defined in url/urlMatcher.ts:211

pattern: string

The pattern that was passed into the constructor

The pattern that was passed into the constructor

- Defined in url/urlMatcher.ts:118

## Methods

- append(url: UrlMatcher): UrlMatcher

- Creates a new concatenated UrlMatcher

- Creates a new concatenated UrlMatcher

  Builds a new UrlMatcher by appending another UrlMatcher to this one.

  #### Parameters

  - ##### url UrlMatcher

    :

    A `UrlMatcher` instance to append as a child of the current `UrlMatcher`.

  #### Returns UrlMatcher

  - Defined in url/urlMatcher.ts:310

- exec(path: string, search?: any, hash?: string, options?: any): RawParams

- Tests the specified url/path against this matcher.

- Tests the specified url/path against this matcher.

  Tests if the given url matches this matcher's pattern, and returns an object containing the captured parameter values. Returns null if the path does not match.

  The returned object contains the values of any search parameters that are mentioned in the pattern, but their value may be null if they are not present in `search`. This means that search parameters are always treated as optional.

  #### Example:

      new UrlMatcher('/user/{id}?q&r').exec('/user/bob', {
        x: '1', q: 'hello'
      });
      // returns { id: 'bob', q: 'hello', r: null }

  #### Parameters

  - ##### path string

    :

    The URL path to match, e.g. `$location.path()`.

  - ##### search: Default value any = {}

    :

    URL search parameters, e.g. `$location.search()`.

  - ##### hash: Optional string

    :

    URL hash e.g. `$location.hash()`.

  - ##### options: Default value any = {}

    :

  #### Returns RawParams

  :

  The captured parameter values.

  - Defined in url/urlMatcher.ts:356

- format(values?: RawParams): string

- Given a set of parameter values, creates a URL from this UrlMatcher.

- Given a set of parameter values, creates a URL from this UrlMatcher.

  Creates a URL that matches this pattern by substituting the specified values for the path and search parameters.

  #### Example:

      new UrlMatcher('/user/{id}?q').format({ id:'bob', q:'yes' });
      // returns '/user/bob?q=yes'

  #### Parameters

  - ##### values: Default value RawParams = {}

    :

    the values to substitute for the parameters in this pattern.

  #### Returns string

  :

  the formatted URL (path and optionally search part).

  - Defined in url/urlMatcher.ts:480

- toString(): string

- Returns the input pattern string

- Returns the input pattern string

  #### Returns string

  - Defined in url/urlMatcher.ts:326

- validates(params: RawParams): boolean

- Validates the input parameter values against this UrlMatcher

- Validates the input parameter values against this UrlMatcher

  Checks an object hash of parameters to validate their correctness according to the parameter types of this `UrlMatcher`.

  #### Parameters

  - ##### params RawParams

    :

    The object hash of parameters to validate.

  #### Returns boolean

  :

  Returns `true` if `params` validates, otherwise `false`.

  - Defined in url/urlMatcher.ts:454

- compare(a: UrlMatcher, b: UrlMatcher): number

- Compare two UrlMatchers

- Compare two UrlMatchers

  This comparison function converts a UrlMatcher into static and dynamic path segments. Each static path segment is a static string between a path separator (slash character). Each dynamic segment is a path parameter.

  The comparison function sorts static segments before dynamic ones.

  #### Parameters

  - ##### a UrlMatcher

  - ##### b UrlMatcher

  #### Returns number

  - Defined in url/urlMatcher.ts:148

Generated using TypeDoc